## sikuli 1.0~x~rc3-dfsg1

=== debian/changelog ===
sikuli (1.0~x~rc3-dfsg1-3build1) precise; urgency=low

  * Rebuild for opencv 2.3 transition

 -- Adrien Cunin <adri2000@ubuntu.com>  Mon, 13 Feb 2012 23:49:03 +0100

sikuli (1.0~x~rc3-dfsg1-3) unstable; urgency=low

  [ Torsten Werner ]
  * Improve executable-wrappers.patch to add asm3-commons.jar to
    runtime CLASSPATH. (Closes: #643563)

 -- Gilles Filippini <pini@debian.org>  Thu, 10 Nov 2011 22:37:06 +0100

sikuli (1.0~x~rc3-dfsg1-2) unstable; urgency=low

  * New patch fix-cmake-sikuli-ide.patch:
    + Fix random FTBFS due to missing inter target dependency

 -- Gilles Filippini <pini@debian.org>  Tue, 04 Oct 2011 23:32:13 +0200

sikuli (1.0~x~rc3-dfsg1-1) unstable; urgency=low

  * New upstream release:
    + Sikuli IDE
      - Auto indentation
      - New settings in preferences: expand tab, tab width, font style, font
        size
      - locale setting
      - ESC cancels screen capture mode
      - Sikuli code (including images) can be copied across tabs
      - Sikuli code can be copied as plain text to other programs/text
        editors
      - Window size and opened files are remembered and restored
        automatically
    + Sikuli Script
      - App class supports Linux now (wmctrl and xdotool required.)
      - Java APIs are more consistent with Jython's
      - New hotkey API allows the user to register hotkeys that trigger a
        Sikuli function
      - A parameter of Sikuli's vision engine MinTargetSize can be changed to
        adjust the robustness/speed of the engine
      - Pure color templates matching
      - popup() accepts an optional parameter for setting the title of the
        dialog
      - Some error messages are improved
    + Bug fixes
      - Closes: #642794.
      - Many bugs in the matching preview window are fixed - not hanging
        anymore, preview is consistent with the result of findAll.

  * orig.tar.gz:
    + drop extensions which should ship into their own source packages since
      they have their own versioning
  * debian/control
    + Multi-Arch support
    + libsikuli-script-java: Depends wmctrl, xdotool
  * debian/rules
    + Multi-Arch support
  * debian/copyright, debian/README.source:
    + More accurate information about how to download the source
    + Updated removed parts list

 -- Gilles Filippini <pini@debian.org>  Tue, 04 Oct 2011 00:57:09 +0200

=== debian/control ===
Source: sikuli
Section: java
Priority: extra
Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Gilles Filippini <pini@debian.org>
Build-Depends: debhelper (>= 8.1.3~), javahelper, default-jdk (>= 1:1.6), cmake, jython, libcv-dev, libcvaux-dev, libhighgui-dev, libcommons-cli-java, junit, libswing-layout-java, libswingx-java, libjxgrabkey-java, libjgoodies-forms-java, libjson-simple-java, libmac-widgets-java, zip, exuberant-ctags, tesseract-ocr-dev, swig,
 default-jdk-doc, jython-doc, junit-doc, libswing-layout-java-doc, libswingx-java-doc, libjxgrabkey-doc, libjgoodies-forms-java-doc, libjson-simple-doc, libmac-widgets-doc,
 python-sphinx
Standards-Version: 3.9.2
Homepage: http://sikuli.org
Vcs-Git: git://git.debian.org/collab-maint/sikuli.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/sikuli.git;a=summary

Package: sikuli-ide
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}, default-jre (>= 1:1.6) | java6-runtime, libsikuli-script-java, junit, libswingx-java
Description: IDE to develop sikuli scripts and use them a junit test cases
 Sikuli mixes image recognition into jython scripting to automate
 interactions with graphical user interfaces.
 .
 With Sikuli it is very easy to programmatically control a web page, a
 desktop application, or even an iphone application running in an emulator.
 .
 This package features Sikuli IDE, the integrated development environment
 for writing visual scripts with screenshots.
 .
 sikuli-ide also provides junit integration for running sikuli scripts as
 junit test cases.

Package: libsikuli-script-java
Architecture: all
Depends: ${java:Depends}, ${misc:Depends}, default-jre (>= 1:1.6) | java6-runtime, libsikuli-script-jni, jython, wmctrl, xdotool
Suggests: libsikuli-script-doc
Description: Visual scripting API for jython
 Sikuli mixes image recognition into Jython scripting to automate
 interactions with graphical user interfaces.
 .
 With Sikuli it is very easy to programmatically control a web page, a
 desktop application, or even an iphone application running in an emulator.
 .
 This package features the jython sikuli visual scripting API and the sikuli
 script interpreter.

Package: libsikuli-script-jni
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Native libs for libsikuli-java
 Sikuli mixes image recognition into jython scripting to automate
 interactions with graphical user interfaces.
 .
 This package holds the architecture dependent jni backend of the java
 library.

Package: libsikuli-script-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-sphinxdoc
Recommends: default-jdk-doc, jython-doc, junit-doc, libswing-layout-java-doc, libjxgrabkey-doc, libjson-simple-doc, libmac-widgets-doc
Description: Documentation for libsikuli-script-java
 Sikuli mixes image recognition into jython scripting to automate
 interactions with graphical user interfaces.
 .
 This package contains the javadoc API documentation for the java library
 libsikuli-script-java.

## sikuli 1.0~x~rc3.tesseract3

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT (sikuli)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/")
INCLUDE(${CMAKE_MODULE_PATH}/common.cmake)

ADD_SUBDIRECTORY(sikuli-script)
ADD_SUBDIRECTORY(sikuli-ide)

INCLUDE(CTest)

=== docs/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/sikuli.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/sikuli.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/sikuli"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/sikuli"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== sikuli-ide/CMakeLists.txt ===
# Copyright 2010-2011, Sikuli.org
# Released under the MIT License.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
PROJECT (sikuli-ide Java)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules")
INCLUDE(${CMAKE_MODULE_PATH}/common.cmake)
INCLUDE(${CMAKE_MODULE_PATH}/detect_osx_ver.cmake)
INCLUDE(${CMAKE_MODULE_PATH}/find_dep_libs.cmake)


ENABLE_TESTING()

SET(CMAKE_VERBOSE_MAKEFILE 0)

FIND_PACKAGE(Java 1.6 REQUIRED)
SET( NON_NATIVE_TARGET TRUE)

IF(UNIX)
   SET(SEP ":")
ELSE()
   SET(SEP ";")
ENDIF()


SET(BASE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
SET(JAVA_SRC_DIR "${BASE_DIR}/src/main/java")
SET(NATIVE_SRC_DIR "${BASE_DIR}/src/main/native")
SET(COMMON_LIB_DIR "${BASE_DIR}/../lib")
SET(INCLUDE_LIB_DIR "${BASE_DIR}/lib")
SET(BINARY_DIR "${BASE_DIR}/target")
SET(BINARY_CLASS_DIR "${BINARY_DIR}/classes")
SET(BINARY_LIB_DIR "${BINARY_DIR}/lib")
SET(JAR_DIR "${BINARY_DIR}/jar")
SET(RESOURCE_DIR "${BASE_DIR}/resources")
SET(RELEASE_DIR "${BASE_DIR}/../release")

SET(JAVA_TEST_DIR "${BASE_DIR}/src/test/java")
SET(TEST_RESOURCE_DIR "test-res")
SET(JAVA_TEST_FOR_HUDSON_XML "../hudson-test.xml")
SET(TEST_CLASS_DIR "${CMAKE_BINARY_DIR}/test") 

SET(SIKULI_SCRIPT_JAR "${COMMON_LIB_DIR}/sikuli-script.jar")
SET(JUNIT_JAR "${COMMON_LIB_DIR}/junit-3.8.1.jar")
SET(SWING_LAYOUT_JAR "${COMMON_LIB_DIR}/swing-layout-1.0.1.jar")
SET(COMMONS_CLI_JAR "${COMMON_LIB_DIR}/commons-cli-1.2.jar")
SET(JSON_SIMPLE_JAR "${COMMON_LIB_DIR}/json_simple-1.1.jar")
SET(SWINGX_JAR "${COMMON_LIB_DIR}/swingx-core-1.6.2.jar")
SET(MAC_WIDGETS_JAR "${COMMON_LIB_DIR}/mac_widgets.jar")
SET(FORMS_JAR "${COMMON_LIB_DIR}/forms-1.2.1.jar")


FILE(MAKE_DIRECTORY ${BINARY_DIR})
FILE(MAKE_DIRECTORY ${BINARY_CLASS_DIR})
FILE(MAKE_DIRECTORY ${JAR_DIR})
FILE(MAKE_DIRECTORY ${TEST_CLASS_DIR})

## Sikuli IDE

SET(MAIN_CLASS org.sikuli.ide.SikuliIDE)
SET(RUN_USER_ARGS -Dsikuli.console=true -Dfile.encoding=UTF-8 
             -Dsikuli.testing=yes
             -Xms64m -Xmx512m 
   CACHE STRING 
   "The arguments for running Sikuli IDE with 'make run-user'"
)
SET(RUN_ARGS -Dsikuli.console=false -Dsikuli.Debug=3 -Dfile.encoding=UTF-8 
             -Dsikuli.testing=yes
             -Xms64m -Xmx512m 
             #-Duser.language=zh -Duser.region=TW 
   CACHE STRING 
   "The arguments for running Sikuli IDE with 'make run'"
)
IF(APPLE)
   LIST(APPEND RUN_ARGS -Xdock:name='Sikuli IDE') 
ENDIF()

#SET(ARGS -s -r ../sample-scripts/mod1.sikuli --args a1 a2) # example args
SET(ARGS "")

SET(CLASSPATH 
   ${SIKULI_SCRIPT_JAR}${SEP}${JUNIT_JAR}${SEP}${SWING_LAYOUT_JAR}${SEP}${COMMONS_CLI_JAR}${SEP}${JSON_SIMPLE_JAR}${SEP}${SWINGX_JAR}${SEP}${MAC_WIDGETS_JAR}${SEP}${FORMS_JAR}
)

SET(JAR_FILE sikuli-ide.jar)
SET(RESOURCES icons META-INF scripts i18n)

IF(LINUX)
   SET(MANIFEST ${RESOURCE_DIR}/META-INF/MANIFEST-linux.MF)
   SET(CLASSPATH ${CLASSPATH}${SEP}${JXGRABKEY_JAR})
ELSEIF(WIN32)
   SET(MANIFEST ${RESOURCE_DIR}/META-INF/MANIFEST-win32.MF)
   #SET(CLASSPATH ${CLASSPATH}${SEP}${JINTELLITYPE_JAR})
ELSE()
   SET(MANIFEST ${RESOURCE_DIR}/META-INF/MANIFEST.MF)
ENDIF()


add_custom_target( ${JAR_FILE} 
   COMMAND ${JAVA_ARCHIVE} cfm ${BINARY_DIR}/${JAR_FILE}
           ${MANIFEST} -C ${JAR_DIR} *
   COMMAND ${CMAKE_COMMAND} -E copy ${BINARY_DIR}/${JAR_FILE} ${COMMON_LIB_DIR}/${JAR_FILE}
   COMMENT "Packaging ${JAR_FILE}"
   WORKING_DIRECTORY ${JAR_DIR}
)

add_custom_target( ${JAR_FILE}.resources
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${RESOURCE_DIR} ${JAR_DIR}
   COMMENT "Copying IDE resources"
)

add_custom_target( ${JAR_FILE}.prepare
   COMMENT "Preparing ${JAR_FILE}"
)

add_custom_target( run-user
   COMMAND ${JAVA_RUNTIME} ${RUN_USER_ARGS} 
                        -classpath "${CLASSPATH}${SEP}${JAR_DIR}"
                        ${MAIN_CLASS} ${ARGS}
)

add_custom_target( run
   COMMAND ${JAVA_RUNTIME} ${RUN_ARGS} 
                        -classpath "${CLASSPATH}${SEP}${JAR_DIR}"
                        ${MAIN_CLASS} ${ARGS}
)

if(NOT DEFINED SIKULI_VERSION OR SIKULI_VERSION STREQUAL "")
   file(READ ${BASE_DIR}/latest-ver SIKULI_VERSION)
   STRING(STRIP ${SIKULI_VERSION} SIKULI_VERSION)
ENDIF()
message("Sikuli Version ${SIKULI_VERSION}")

SET(JYTHON_CLASS org.python.util.jython)
add_custom_target( update-version
      COMMAND ${JAVA_RUNTIME} -cp "${CLASSPATH}" ${JYTHON_CLASS} ${BASE_DIR}/../utils/update-version.py  ${JAVA_SRC_DIR}/org/sikuli/ide/IDESettings.java "${SIKULI_VERSION}"
   COMMENT "Update version number in Sikuli-IDE"
)

SET(INCLUDE_JARS ${SIKULI_SCRIPT_JAR} ${JUNIT_JAR} 
                 ${SWING_LAYOUT_JAR} ${COMMONS_CLI_JAR}
                 ${BINARY_DIR}/${JAR_FILE} ${JSON_SIMPLE_JAR}
                 ${SWINGX_JAR} ${MAC_WIDGETS_JAR} ${FORMS_JAR}
)

## Windows Package

IF(WIN32)
   SET(OS "win32")
   SET(APP_FILE "Sikuli-IDE")
   SET(BINARY_APP_DIR  "${BINARY_DIR}/${OS}")
   SET(JAR_IN_APP_DIR  ${BINARY_APP_DIR}/${APP_FILE})
   SET(FRAMEWORKS_IN_APP_DIR  ${JAR_IN_APP_DIR}/libs)
   SET(JAR_LIB_DIR  ${JAR_DIR}/META-INF/lib)

   #LIST(APPEND INCLUDE_JARS ${JINTELLITYPE_JAR})
   FILE(GLOB sikuli_script_jnilibs "${BASE_DIR}/../sikuli-script/target/lib/*.dll")
   SET(jnilibs ${sikuli_script_jnilibs})
ENDIF()

## Linux Package

IF(LINUX)
   SET(OS "linux")
   SET(APP_FILE "Sikuli-IDE")
   SET(BINARY_APP_DIR  "${BINARY_DIR}/${OS}")
   SET(JAR_IN_APP_DIR  ${BINARY_APP_DIR}/${APP_FILE})
   SET(FRAMEWORKS_IN_APP_DIR  ${JAR_IN_APP_DIR}/libs)
   SET(JAR_LIB_DIR  ${JAR_DIR}/META-INF/lib)

   LIST(APPEND INCLUDE_JARS ${JXGRABKEY_JAR})
   SET(jnilibs "")
   FILE(GLOB sikuli_script_jnilibs "${BASE_DIR}/../sikuli-script/target/lib/*.so")
   LIST(APPEND jnilibs ${sikuli_script_jnilibs})
ENDIF(LINUX)

## Sikuli-IDE.App for Mac OS X

IF(APPLE)
   IF(APPLE_SNOW_LEOPARD)
      SET(OSX_VER "osx-10.6")
   ELSEIF(APPLE_LEOPARD)
      SET(OSX_VER "osx-10.5")
   ENDIF()
   SET(OS ${OSX_VER})

   SET(APP_FILE  "Sikuli-IDE.app")
   SET(BINARY_APP_DIR  "${BINARY_DIR}/${OS}")
   SET(JAR_IN_APP_DIR  ${BINARY_APP_DIR}/${APP_FILE}/Contents/Resources/Java)
   SET(FRAMEWORKS_IN_APP_DIR  ${BINARY_APP_DIR}/${APP_FILE}/Contents/Frameworks)

   FIND_PACKAGE(OpenCV REQUIRED)
   #message("opencv lib: ${OpenCV_LIB_DIR}")
   LIST(APPEND CMAKE_LIBRARY_PATH ${OpenCV_LIB_DIR})

   FILE(GLOB jnilibs "${BINARY_LIB_DIR}/*.jnilib")
   FILE(GLOB sikuli_script_jnilibs "${BASE_DIR}/../sikuli-script/target/lib/*.jnilib")
   LIST(APPEND jnilibs ${sikuli_script_jnilibs})

   find_dep_libs("${jnilibs}" deplibs)
   find_dep_libs("${deplibs}" deplibs)
   #MESSAGE("Dep: ${deplibs}")

ENDIF(APPLE)

SET(RELEASE_FILE "Sikuli-${SIKULI_VERSION}-${OS}")

## Packaging App
add_custom_target( ${APP_FILE}
   COMMENT "Generate ${BINARY_DIR}/${APP_FILE}"
)

add_dependencies( ${APP_FILE} ${JAR_FILE} )

IF(LINUX)
   EXEC_PROGRAM(uname ARGS -m OUTPUT_VARIABLE SYSTEM_ARCH)
   SET(RELEASE_FILE "${RELEASE_FILE}-${SYSTEM_ARCH}")
   if(SYSTEM_ARCH MATCHES "x86_64")
      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jxgrabkey/lib/libJXGrabKey-64.so")
   else()
      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jxgrabkey/lib/libJXGrabKey-32.so")
   endif()

   add_custom_target( ${APP_FILE}.framework 
      COMMAND ${CMAKE_COMMAND} -E make_directory ${FRAMEWORKS_IN_APP_DIR}
      COMMAND cp ${jnilibs} ${FRAMEWORKS_IN_APP_DIR}
      COMMAND cp ${LIB_GRABKEY} ${FRAMEWORKS_IN_APP_DIR}/libJXGrabKey.so
      COMMENT "Packaging Frameworks in App"
   )
   add_dependencies( ${APP_FILE} ${APP_FILE}.framework ) 

ENDIF(LINUX)

IF(WIN32)
   SET(APP_FILES Sikuli-IDE-w.bat Sikuli-IDE.bat Sikuli-IDE.exe ide-icon.ico)
   SET(WIN32_LIBS ${COMMON_LIB_DIR}/win32)
   SET(OPENCV_LIBS cv210 cvaux210 cxcore210 highgui210 ml210)

   SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jintellitype-1.3.6/JIntellitype.dll")
   add_custom_target( ${JAR_FILE}.framework 
      COMMAND ${CMAKE_COMMAND} -E make_directory ${JAR_LIB_DIR}
      COMMAND ${CMAKE_COMMAND} -E copy ${LIB_GRABKEY} ${JAR_LIB_DIR}/
      COMMENT "Packaging Frameworks in Jar"
   )
   add_dependencies( ${JAR_FILE} ${JAR_FILE}.framework ) 

   add_custom_target( ${APP_FILE}.framework 
      COMMAND ${CMAKE_COMMAND} -E make_directory ${FRAMEWORKS_IN_APP_DIR}
      COMMAND ${CMAKE_COMMAND} -E copy_directory ${WIN32_LIBS} ${FRAMEWORKS_IN_APP_DIR}
      COMMENT "Packaging Frameworks in App"
   )
   add_dependencies( ${APP_FILE} ${APP_FILE}.framework ) 

   #libs

   install(FILES ${jnilibs}
           DESTINATION ${FRAMEWORKS_IN_APP_DIR})
   FOREACH(F ${OPENCV_LIBS})
      install(FILES ${OpenCV_DIR}/bin/${F}.dll
              DESTINATION ${FRAMEWORKS_IN_APP_DIR})
   ENDFOREACH()

   FOREACH(F ${APP_FILES})
      install(FILES ${BINARY_APP_DIR}/${F}
              DESTINATION ${JAR_IN_APP_DIR})

   ENDFOREACH()
ENDIF(WIN32)

IF(APPLE)
   add_custom_target( ${APP_FILE}.framework 
      COMMAND ${CMAKE_COMMAND} -E make_directory ${FRAMEWORKS_IN_APP_DIR}
      COMMAND cp -f ${jnilibs} ${FRAMEWORKS_IN_APP_DIR}
      COMMAND cp -f ${deplibs} ${FRAMEWORKS_IN_APP_DIR}
      COMMAND ${CMAKE_COMMAND} -E chdir ${FRAMEWORKS_IN_APP_DIR} ./change-lib-path.sh
      COMMENT "Packaging Frameworks"
   )

   add_custom_target( ${APP_FILE}.update_ver
	COMMAND defaults write ${BINARY_APP_DIR}/${APP_FILE}/Contents/Info CFBundleVersion `echo ${SIKULI_VERSION} | awk '{print $$1}'`
	COMMAND plutil -convert xml1 ${BINARY_APP_DIR}/${APP_FILE}/Contents/Info.plist
   )

   add_dependencies( ${APP_FILE} ${APP_FILE}.framework ${APP_FILE}.update_ver)

ENDIF(APPLE)

install(DIRECTORY ${BINARY_APP_DIR}/${APP_FILE}
   USE_SOURCE_PERMISSIONS
   DESTINATION .
)


add_custom_target( app ALL
)


FOREACH(JAR ${INCLUDE_JARS})
   get_filename_component(JAR_FILENAME ${JAR} NAME)
   get_filename_component(target ${JAR} NAME_WE)
   set(target "include_${target}")
   add_custom_target( ${target}
      COMMAND ${CMAKE_COMMAND} -E copy ${JAR} ${JAR_IN_APP_DIR}/${JAR_FILENAME}
                  
      COMMENT "Copying ${JAR_FILENAME}"
   )
   add_dependencies( ${APP_FILE} ${target} )
ENDFOREACH(JAR ${INCLUDE_JARS})


add_dependencies( app ${APP_FILE})

## Language files

add_custom_target( update-po
   COMMAND prop2po ${RESOURCE_DIR}/i18n/IDE_en_US.properties > ${RESOURCE_DIR}/i18n/IDE/IDE.pot
               
   COMMENT "Update the IDE.pot file"
)

add_custom_target( update-prop
   COMMAND ${BASE_DIR}/../utils/update-prop.sh ${RESOURCE_DIR}
   COMMENT "Update the IDE language properties."
)


## Packaging

if(APPLE)
      SET(CPACK_GENERATOR DragNDrop )
      #   SET(CPACK_GENERATOR ZIP )
else(APPLE)
   SET(CPACK_GENERATOR 
      ZIP
   )
endif(APPLE)

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Sikuli ${SIKULI_VERSION}")
SET(CPACK_PACKAGE_VENDOR "Sikuli Development Team")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${BASE_DIR}/../readme.txt")
SET(CPACK_RESOURCE_FILE_LICENSE "${BASE_DIR}/../copyright.txt")
SET(CPACK_PACKAGE_FILE_NAME ${RELEASE_FILE})

INCLUDE(CPack)

install(FILES 
   ${CPACK_PACKAGE_DESCRIPTION_FILE}
   ${CPACK_RESOURCE_FILE_LICENSE}
   DESTINATION .
)

# type "make package" to generate release packages


## tests

SET(MAIN_TEST_SUITE ${PACKAGE}.SikuliIDETestSuite)

add_custom_target( java-test.test-res
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${BASE_DIR}/${TEST_RESOURCE_DIR} ${CMAKE_BINARY_DIR}/${TEST_RESOURCE_DIR}
   COMMENT "Copy test resource"
)

add_custom_target( java-test
   #   COMMAND ${JAVA_RUNTIME} -cp ${TEST_CLASS_DIR}${SEP}${BINARY_DIR}/${JAR_FILE}${SEP}${JUNIT_JAR} junit.textui.TestRunner ${MAIN_TEST_SUITE}
   COMMAND ant -f ${JAVA_TEST_FOR_HUDSON_XML}
   COMMENT "Run Java unit tests"
)

add_dependencies( java-test
        ${JAR_FILE}
        ${PROJECT_NAME}.test.classes
        java-test.test-res
)

add_custom_target( all-test
)

add_dependencies( all-test
   java-test   
)

## Dependencies

add_dependencies( ${JAR_FILE}.prepare
        ${JAR_FILE}.resources
        ${JAR_FILE}.classes-in-jar 
        #        ${JAR_FILE}.libs-in-jar
)

add_dependencies( ${JAR_FILE} ${JAR_FILE}.prepare )
add_dependencies( run-user ${JAR_FILE})
add_dependencies( run ${JAR_FILE})
add_dependencies( app ${APP_FILE})

=== sikuli-script/CMakeLists.txt ===
# Copyright 2010-2011, Sikuli.org
# Released under the MIT License.
cmake_minimum_required(VERSION 2.6)
PROJECT (sikuli-script Java)

ENABLE_TESTING()

SET(CMAKE_VERBOSE_MAKEFILE 0)
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/")
INCLUDE("${CMAKE_MODULE_PATH}/common.cmake")

FIND_PACKAGE(Java 1.6 REQUIRED)
SET( NON_NATIVE_TARGET TRUE)

IF(UNIX)
   SET(SEP ":")
ELSE()
   SET(SEP ";")
ENDIF()

SET(NATIVE_PACKAGE org.sikuli.script.natives)
STRING(REPLACE . / NATIVE_PACKAGE_DIR ${NATIVE_PACKAGE})

SET(PACKAGE org.sikuli.script)
STRING(REPLACE . / PACKAGE_DIR ${PACKAGE})

SET(BASE_DIR "${CMAKE_CURRENT_SOURCE_DIR}")
SET(DOC_DIR "${BASE_DIR}/doc")
SET(JAVA_SRC_DIR "${BASE_DIR}/src/main/java")
SET(NATIVE_SRC_DIR "${BASE_DIR}/src/main/native")
SET(PYTHON_SRC_DIR "${BASE_DIR}/src/main/python")
SET(JAVA_TEST_DIR "${BASE_DIR}/src/test/java")
SET(TEST_RESOURCE_DIR "test-res")
SET(JAVA_TEST_FOR_HUDSON_XML "../hudson-test.xml")

SET(CMAKE_SWIG_OUTDIR ${CMAKE_BINARY_DIR}/${NATIVE_PACKAGE_DIR})

SET(COMMON_LIB_DIR "${BASE_DIR}/../lib")

# dependent libs
SET(JXGRABKEY_JAR "${COMMON_LIB_DIR}/jxgrabkey/lib/JXGrabKey.jar")
SET(JINTELLITYPE_JAR "${COMMON_LIB_DIR}/jintellitype-1.3.6/jintellitype-1.3.6.jar")

#SET(INCLUDE_LIB_DIR "${BASE_DIR}/lib")
SET(INCLUDE_LIB_DIR "${COMMON_LIB_DIR}/mx-native-loader-1.2/target/classes")

SET(BINARY_DIR "${BASE_DIR}/target")
SET(BINARY_CLASS_DIR "${CMAKE_BINARY_DIR}/classes")
SET(TEST_CLASS_DIR "${CMAKE_BINARY_DIR}/test")
SET(BINARY_LIB_DIR "${BINARY_DIR}/lib")
SET(JAR_DIR "${CMAKE_BINARY_DIR}/jar")
SET(JAR_LIB_DIR  ${JAR_DIR}/META-INF/lib)

SET(JUNIT_JAR "${COMMON_LIB_DIR}/junit-4.8.2.jar")
SET(MOCKITO_JAR "${COMMON_LIB_DIR}/mockito-all-1.8.5.jar")
SET(JYTHON_JAR "${COMMON_LIB_DIR}/jython-2.5.2.jar")
SET(JYTHON_LIB_FILE "${COMMON_LIB_DIR}/jython-lib-2.5.2.tgz")

SET(CLASSPATH 
   ${INCLUDE_LIB_DIR}${SEP}${JYTHON_JAR}${SEP}.
)

IF(LINUX)
   SET(CLASSPATH ${CLASSPATH}${SEP}${JXGRABKEY_JAR})
ELSEIF(WIN32)
   SET(CLASSPATH ${CLASSPATH}${SEP}${JINTELLITYPE_JAR})
ENDIF()


SET(TEST_CLASSPATH
   ${CLASSPATH}${SEP}${JUNIT_JAR}${SEP}${BINARY_CLASS_DIR}${SEP}${MOCKITO_JAR}
)

FILE(MAKE_DIRECTORY ${BINARY_DIR})
FILE(MAKE_DIRECTORY ${BINARY_CLASS_DIR})
FILE(MAKE_DIRECTORY ${TEST_CLASS_DIR})
FILE(MAKE_DIRECTORY ${JAR_DIR})

SET(JAR_FILE sikuli-script.jar)

add_custom_target( ${JAR_FILE} ALL
   COMMAND ${JAVA_ARCHIVE} cfm ${BINARY_DIR}/${JAR_FILE}
           ${BINARY_DIR}/MANIFEST.txt -C ${JAR_DIR} *
   COMMAND ${CMAKE_COMMAND} -E copy ${BINARY_DIR}/${JAR_FILE} ${COMMON_LIB_DIR}/${JAR_FILE}
   COMMENT "Preparing and packaging ${JAR_FILE}"
   WORKING_DIRECTORY ${JAR_DIR}
)

add_custom_target( ${JAR_FILE}.includes-in-jar 
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${INCLUDE_LIB_DIR} ${JAR_DIR}
)

IF(NOT EXISTS ${JAR_DIR}/org/python)
   add_custom_target( ${JAR_FILE}.jython-in-jar
      COMMAND ${CMAKE_COMMAND} -E chdir ${JAR_DIR} ${JAVA_ARCHIVE} xf ${JYTHON_JAR}
      COMMENT "Merging Jython's JAR"
   )
ENDIF()


SET(LIB_IN_JAR_DIR "${JAR_DIR}/Lib")
add_custom_target( ${JAR_FILE}.python-src-in-jar
   COMMAND ${CMAKE_COMMAND} -E make_directory ${LIB_IN_JAR_DIR}
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${PYTHON_SRC_DIR} ${LIB_IN_JAR_DIR}
   COMMENT "Copying Sikuli's Python Source"
)

IF(NOT EXISTS ${LIB_IN_JAR_DIR}/glob.py)
   add_custom_target( ${JAR_FILE}.jython-libs-in-jar
      COMMAND ${CMAKE_COMMAND} -E make_directory ${LIB_IN_JAR_DIR}
      COMMAND ${CMAKE_COMMAND} -E chdir ${LIB_IN_JAR_DIR} 
              ${CMAKE_COMMAND} -E tar xzf ${JYTHON_LIB_FILE}
      COMMENT "Copying Jython Libraries"
   )
ENDIF()

SET(TESSDATA_IN_JAR_DIR "${JAR_DIR}/tessdata")
SET(TESSDATA_LIST_TXT "${BINARY_DIR}/tessdata-list.txt")
   add_custom_target( ${JAR_FILE}.tessdata-in-jar
      COMMAND ${CMAKE_COMMAND} -E make_directory ${TESSDATA_IN_JAR_DIR}
      COMMAND ${CMAKE_COMMAND} -E copy_directory ${TESSERACT_DATA_DIR} ${TESSDATA_IN_JAR_DIR}
      COMMAND ${CMAKE_COMMAND} -E copy_if_different ${TESSDATA_LIST_TXT} ${TESSDATA_IN_JAR_DIR}/filelist.txt
      #      COMMAND cd ${TESSDATA_IN_JAR_DIR} && (find . -type f > filelist.txt)
      COMMENT "Copying Tesseract Data"
   )

add_custom_target(doc
   javadoc -public -docencoding utf-8 -windowtitle "Javadoc of Sikuli Script" -sourcepath ${JAVA_SRC_DIR}
    -d ${DOC_DIR} -classpath ${CLASSPATH}  ${PACKAGE}
)

SET(RUN_SCRIPT_ARGS 
   "-i"
   CACHE STRING 
   "The arguments for running Sikuli Script with 'make run-script'")
add_custom_target(run-script
   java -jar ${BINARY_DIR}/${JAR_FILE} ${RUN_SCRIPT_ARGS}
)

file(READ ${BASE_DIR}/../sikuli-ide/latest-ver VERSION)
STRING(STRIP ${VERSION} VERSION)

add_custom_target( update-version
      COMMAND ${BASE_DIR}/../utils/update-version.sh  ${JAVA_SRC_DIR}/org/sikuli/script/Env.java "${VERSION}"
      COMMENT "Update version number to ${VERSION}"
)

add_custom_target(${JAR_FILE}.libs-in-jar
   COMMAND ${CMAKE_COMMAND} -E make_directory ${JAR_DIR}/META-INF
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_LIB_DIR} ${JAR_LIB_DIR}
   COMMENT "Build native libs"
)


# Dependencies

add_dependencies(${JAR_FILE} 
        ${JAR_FILE}.classes-in-jar 
        ${JAR_FILE}.python-src-in-jar
        ${JAR_FILE}.tessdata-in-jar
        ${JAR_FILE}.libs-in-jar
        ${JAR_FILE}.includes-in-jar
        ${JAR_FILE}.jython-in-jar
        ${JAR_FILE}.jython-libs-in-jar
)

IF(WIN32)
   IF(NOT EXISTS ${JAR_DIR}/com/melloware/jintellitype)
      add_custom_target( ${JAR_FILE}.jintellitype-in-jar
         COMMAND ${CMAKE_COMMAND} -E chdir ${JAR_DIR} ${JAVA_ARCHIVE} xf ${JINTELLITYPE_JAR}
         COMMENT "Merging Jintellitype's JAR"
      )
      add_dependencies(${JAR_FILE} 
         ${JAR_FILE}.jintellitype-in-jar
      )

      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jintellitype-1.3.6/JIntellitype.dll")
      SET(LIB_GRABKEY64 "${COMMON_LIB_DIR}/jintellitype-1.3.6/JIntellitype64.dll")
      add_custom_target( ${JAR_FILE}.hotkey-lib 
         COMMAND ${CMAKE_COMMAND} -E copy ${LIB_GRABKEY} ${JAR_DIR}/com/melloware/jintellitype/
         COMMAND ${CMAKE_COMMAND} -E copy ${LIB_GRABKEY64} ${JAR_DIR}/com/melloware/jintellitype/
         COMMENT "Packaging JIntellitype in Jar"
      )
      add_dependencies( ${JAR_FILE}.hotkey-lib
         ${JAR_FILE}.jintellitype-in-jar 
      )
   ENDIF(NOT EXISTS ${JAR_DIR}/com/melloware/jintellitype)

ENDIF(WIN32)

IF(LINUX)
   IF(NOT EXISTS ${JAR_DIR}/jxgrabkey)
      add_custom_target( ${JAR_FILE}.jxgrabkey-in-jar
         COMMAND ${CMAKE_COMMAND} -E chdir ${JAR_DIR} ${JAVA_ARCHIVE} xf ${JXGRABKEY_JAR}
         COMMENT "Merging JXGrabKey's JAR"
      )
   ENDIF()

   add_dependencies(${JAR_FILE} 
      ${JAR_FILE}.jxgrabkey-in-jar
   )
ENDIF(LINUX)

IF(LINUX)
   EXEC_PROGRAM(uname ARGS -m OUTPUT_VARIABLE SYSTEM_ARCH)
   if(SYSTEM_ARCH MATCHES "x86_64")
      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jxgrabkey/lib/libJXGrabKey-64.so")
   else()
      SET(LIB_GRABKEY "${COMMON_LIB_DIR}/jxgrabkey/lib/libJXGrabKey-32.so")
   endif()
   add_custom_target( ${JAR_FILE}.hotkey-lib 
      COMMAND cp ${LIB_GRABKEY} ${BINARY_LIB_DIR}/libJXGrabKey.so
      COMMENT "Packaging JXGrabKey in Jar"
   )
ENDIF(LINUX)
add_dependencies( ${JAR_FILE} ${JAR_FILE}.hotkey-lib ) 
add_dependencies( ${JAR_FILE}.libs-in-jar ${JAR_FILE}.hotkey-lib ) 


ADD_SUBDIRECTORY(${JAVA_SRC_DIR})
ADD_SUBDIRECTORY(${NATIVE_SRC_DIR})
ADD_SUBDIRECTORY(${JAVA_TEST_DIR})

# Java level tests

SET(MAIN_TEST_SUITE ${PACKAGE}.SikuliScriptTestSuite)

add_custom_target( test-res
   COMMAND ${CMAKE_COMMAND} -E remove_directory ${CMAKE_BINARY_DIR}/${TEST_RESOURCE_DIR}
   COMMAND ${CMAKE_COMMAND} -E copy_directory ${BASE_DIR}/${TEST_RESOURCE_DIR} ${CMAKE_BINARY_DIR}/${TEST_RESOURCE_DIR}
   COMMENT "Copy test resource"
)

SET(JAVA_TEST_CASE ""
   CACHE STRING
   "The java test case to run with run-java-test"
   )

add_custom_target( run-java-test
   COMMAND ant -f ${JAVA_TEST_FOR_HUDSON_XML} runtest -Dtest=${JAVA_TEST_CASE}
   COMMENT "Run specific Java unit tests"
)

add_dependencies( run-java-test
        ${JAR_FILE}
        ${PROJECT_NAME}.test.classes
        test-res
)

add_custom_target( java-test
   COMMAND ant -f ${JAVA_TEST_FOR_HUDSON_XML}
   COMMENT "Run Java unit tests"
)

add_dependencies( java-test
        ${JAR_FILE}
        ${PROJECT_NAME}.test.classes
        test-res
)


## Python level tests

SET(PY_TEST_DIR "${BASE_DIR}/src/test/python")
SET(JYTHON_CLASS org.python.util.jython)
SET(JACOCOAGENT_JAR ${BASE_DIR}/../utils/jacoco/lib/jacocoagent.jar)
IF(WIN32)
   STRING(REPLACE "/" "\\" JACOCOAGENT_JAR "${JACOCOAGENT_JAR}")
ENDIF(WIN32)
SET(JACOCO_ARGS
   "-javaagent:${JACOCOAGENT_JAR}=destfile=jacoco.exec,includes=org.sikuli.*"
)

SET(NOSE_ARGS
   ""
   CACHE STRING 
   "The arguments for running Python nose tests")

add_custom_target( python-test
   COMMAND ${JAVA_RUNTIME} "${JACOCO_ARGS}"  -Dfile.encoding=UTF-8 -Dsikuli.testing=yes -cp "${BINARY_DIR}/${JAR_FILE}${SEP}${TEST_CLASS_DIR}" ${JYTHON_CLASS} ${PY_TEST_DIR}/RunNoseTests.py ${NOSE_ARGS}
   COMMENT "Run Python unit tests"
)

add_dependencies( python-test
   ${JAR_FILE}
   ${PROJECT_NAME}.test.classes
   test-res
)


# run all test cases
add_custom_target( all-test
)

add_dependencies( all-test
   java-test
   python-test
)

=== sikuli-ide/src/main/java/CMakeLists.txt ===
# Copyright 2010-2011, Sikuli.org
# Released under the MIT License.
IF(APPLE)
   SET(OS_EXTRA_SOURCE_FILES org/sikuli/ide/NativeLayerForMac.java)
ELSEIF(LINUX)
   SET(OS_EXTRA_SOURCE_FILES org/sikuli/ide/NativeLayerForLinux.java)
ELSEIF(WIN32)
   SET(OS_EXTRA_SOURCE_FILES org/sikuli/ide/NativeLayerForWindows.java)
ENDIF()

SET(JAVA_SOURCE_FILES 
         ${OS_EXTRA_SOURCE_FILES}
         org/sikuli/ide/AutoUpdater.java
         org/sikuli/ide/ButtonGenCommand.java
         org/sikuli/ide/CaptureButton.java
         org/sikuli/ide/CloseableTabbedPane.java
         org/sikuli/ide/CloseableTabbedPaneListener.java
         org/sikuli/ide/CommandArgs.java
         org/sikuli/ide/ConsolePane.java
         org/sikuli/ide/CurrentLineHighlighter.java
         org/sikuli/ide/FileChooser.java
         org/sikuli/ide/I18N.java
         org/sikuli/ide/IDESettings.java
         org/sikuli/ide/ImageButton.java
         org/sikuli/ide/LineNumberView.java
         org/sikuli/ide/MyDocument.java
         org/sikuli/ide/NativeLayer.java
         org/sikuli/ide/Observer.java
         org/sikuli/ide/PatternWindow.java
         org/sikuli/ide/PreferencesWin.java
         org/sikuli/ide/RegionButton.java
         org/sikuli/ide/ScreenshotPane.java
         org/sikuli/ide/sikuli_test/CounterPanel.java
         org/sikuli/ide/sikuli_test/DefaultFailureDetailView.java
         org/sikuli/ide/sikuli_test/FailureRunView.java
         org/sikuli/ide/sikuli_test/ProgressBar.java
         org/sikuli/ide/sikuli_test/TestHierarchyRunView.java
         org/sikuli/ide/sikuli_test/TestRunContext.java
         org/sikuli/ide/sikuli_test/TestRunView.java
         org/sikuli/ide/sikuli_test/TestSuitePanel.java
         org/sikuli/ide/sikuli_test/TestTreeModel.java
         org/sikuli/ide/sikuli_test/TextUnitTestRunner.java
         org/sikuli/ide/sikuli_test/UnitTestRunner.java
         org/sikuli/ide/SikuliDocument.java
         org/sikuli/ide/SikuliEditorKit.java
         org/sikuli/ide/SikuliIDE.java
         org/sikuli/ide/SikuliPane.java
         org/sikuli/ide/SikuliView.java
         org/sikuli/ide/SikuliViewFactory.java
         org/sikuli/ide/SimilaritySlider.java
         org/sikuli/ide/StatusBar.java
         org/sikuli/ide/Subject.java
         org/sikuli/ide/TargetOffsetPane.java
         org/sikuli/ide/ToolbarButton.java
         org/sikuli/ide/UserPreferences.java
         org/sikuli/ide/Utils.java
         org/sikuli/ide/NamingPane.java
         org/sikuli/ide/ModernTabbedPaneUI.java
         org/sikuli/ide/UndoManager.java
         org/sikuli/ide/BevelDividerPainter.java
         org/sikuli/ide/extmanager/ExtensionItem.java
         org/sikuli/ide/extmanager/ExtensionManagerFrame.java
         org/sikuli/ide/indentation/PythonIndentation.java
         org/sikuli/ide/indentation/PythonState.java
         org/sikuli/ide/util/GifDecoder.java
         org/sikuli/ide/util/LoadingSpinner.java
)

add_custom_target( ${PROJECT_NAME}.classes
    COMMAND ${JAVA_COMPILE} -d ${BINARY_CLASS_DIR} -classpath "${CLASSPATH}"
            ${JAVA_SOURCE_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
     

add_custom_target( ${JAR_FILE}.classes-in-jar
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_CLASS_DIR} ${JAR_DIR}
)

add_dependencies(${JAR_FILE}.classes-in-jar ${PROJECT_NAME}.classes)

=== sikuli-ide/src/test/java/CMakeLists.txt ===
# Copyright 2010-2011, Sikuli.org
# Released under the MIT License.

SET(JAVA_TEST_FILES 
   org/sikuli/ide/*.java
   org/sikuli/ide/indentation/*.java
)

add_custom_target( ${PROJECT_NAME}.test.classes
    COMMAND ${JAVA_COMPILE} -d ${TEST_CLASS_DIR} -classpath "${CLASSPATH}${SEP}${JUNIT_JAR}${SEP}${BINARY_CLASS_DIR}"
            ${JAVA_TEST_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
     

add_dependencies(${PROJECT_NAME}.test.classes ${PROJECT_NAME}.classes)

=== sikuli-script/src/main/java/CMakeLists.txt ===
# Copyright 2010-2011, Sikuli.org
# Released under the MIT License.
IF(APPLE)
   SET(OS_EXTRA_SOURCE_FILES 
      org/sikuli/script/MacUtil.java
      org/sikuli/script/internal/hotkey/MacHotkeyManager.java
   )
ELSEIF(LINUX)
   SET(OS_EXTRA_SOURCE_FILES 
      org/sikuli/script/LinuxUtil.java
      org/sikuli/script/internal/hotkey/LinuxHotkeyManager.java
      )
ELSEIF(WIN32)
   SET(OS_EXTRA_SOURCE_FILES 
      org/sikuli/script/Win32Util.java
      org/sikuli/script/internal/hotkey/WindowsHotkeyManager.java
      )
ENDIF()


SET(JAVA_SOURCE_FILES 
   ${CMAKE_SWIG_OUTDIR}/*.java
   ${OS_EXTRA_SOURCE_FILES}
   org/sikuli/script/AppearEvent.java
   org/sikuli/script/CapturePrompt.java
   org/sikuli/script/ChangeEvent.java
   org/sikuli/script/Clipboard.java
   org/sikuli/script/Debug.java
   org/sikuli/script/DummyOSUtil.java
   org/sikuli/script/Env.java
   org/sikuli/script/EventManager.java
   org/sikuli/script/FindFailed.java
   org/sikuli/script/Finder.java
   org/sikuli/script/KeyCodeConverter.java
   org/sikuli/script/Location.java
   org/sikuli/script/Match.java
   org/sikuli/script/OS.java
   org/sikuli/script/OSUtil.java
   org/sikuli/script/Observer.java
   org/sikuli/script/OpenCV.java
   org/sikuli/script/ScreenHighlighter.java
   org/sikuli/script/Pattern.java
   org/sikuli/script/Region.java
   org/sikuli/script/Screen.java
   org/sikuli/script/ScreenImage.java
   org/sikuli/script/ScriptRunner.java
   org/sikuli/script/Settings.java
   org/sikuli/script/SikuliEvent.java
   org/sikuli/script/SikuliEventAdapter.java
   org/sikuli/script/SikuliEventObserver.java
   org/sikuli/script/SikuliScript.java
   org/sikuli/script/Subject.java
   org/sikuli/script/UnionScreen.java
   org/sikuli/script/VDictProxy.java
   org/sikuli/script/VanishEvent.java
   org/sikuli/script/App.java
   org/sikuli/script/ImageLocator.java
   org/sikuli/script/ResourceExtractor.java
   org/sikuli/script/SikuliException.java
   org/sikuli/script/AppNotFound.java
   org/sikuli/script/Animator.java
   org/sikuli/script/TransparentWindow.java
   org/sikuli/script/ExtensionManager.java
   org/sikuli/script/Key.java
   org/sikuli/script/KeyModifier.java
   org/sikuli/script/Button.java
   org/sikuli/script/Constants.java
   org/sikuli/script/internal/hotkey/HotkeyManager.java
)

add_custom_target( ${PROJECT_NAME}.classes
    COMMAND ${JAVA_COMPILE} -d ${BINARY_CLASS_DIR} -classpath "${CLASSPATH}"
            ${JAVA_SOURCE_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
     

add_custom_target( ${JAR_FILE}.classes-in-jar
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${BINARY_CLASS_DIR} ${JAR_DIR}
)

add_dependencies(${JAR_FILE}.classes-in-jar ${PROJECT_NAME}.classes)
add_dependencies(${PROJECT_NAME}.classes VisionProxy)

=== sikuli-script/src/main/native/CMakeLists.txt ===
# Copyright 2010-2011, Sikuli.org
# Released under the MIT License.
ENABLE_LANGUAGE(CXX)

IF(LINUX)
   # -O2/O3 seems incorrectly optimizes some SWIG generated code
   SET(CMAKE_CXX_FLAGS_RELEASE "-O1")
ENDIF(LINUX)

SET(CMAKE_VERBOSE_MAKEFILE 1)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../../../cmake_modules/")
INCLUDE("${CMAKE_MODULE_PATH}/common.cmake")


FIND_PROGRAM ( JAVA_JAVA_H javah PATHS ${JAVA_BIN_PATH} )
SET(JNI_HEADERS
   org_sikuli_script_VDictProxy.h
   org_sikuli_script_Win32Util.h
   org_sikuli_script_MacUtil.h
   org_sikuli_script_internal_hotkey_MacHotkeyManager.h
)

SET(LIBRARY_OUTPUT_PATH ${BINARY_LIB_DIR})

FIND_PACKAGE(OpenCV REQUIRED)
FIND_PACKAGE(JNI REQUIRED)
FIND_PACKAGE(SWIG REQUIRED)

INCLUDE_DIRECTORIES(${JNI_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${OPENCV_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE(${SWIG_USE_FILE})

# profiling
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_TIMING")
# visual logger for debugging
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_VISUAL_LOG")
# OCR matching debug
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_OCR_DEBUG")
# enable the debug message in finder
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG_FINDER")
# use GPU in template matcher
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DENABLE_GPU")

IF(NOT WIN32)
   FIND_PACKAGE(Tesseract REQUIRED)
   INCLUDE_DIRECTORIES(${Tesseract_INCLUDE_DIR})
ELSE()
   SET(TESSERACT_SRC_DIRS ccmain ccutil ccstruct viewer 
                          image textord wordrec dict cutil
                          classify aspirin dict display pageseg)
   FOREACH(DIR ${TESSERACT_SRC_DIRS})
      FILE(GLOB T_SRCS 
         ${TESSERACT_SRC_DIR}/${DIR}/*.cpp
      )
      SET(TESSERACT_SOURCES ${TESSERACT_SOURCES} ${T_SRCS})
      INCLUDE_DIRECTORIES(${TESSERACT_SRC_DIR}/${DIR})
   ENDFOREACH()
   LIST(REMOVE_ITEM TESSERACT_SOURCES ${TESSERACT_SRC_DIR}/ccmain/tessembedded.cpp)
   LIST(REMOVE_ITEM TESSERACT_SOURCES ${TESSERACT_SRC_DIR}/ccutil/scanutils.cpp)
   LIST(REMOVE_ITEM TESSERACT_SOURCES ${TESSERACT_SRC_DIR}/viewer/svpaint.cpp)

   INCLUDE_DIRECTORIES($ENV{INCLUDE})
   LINK_DIRECTORIES($ENV{LIB})
   SET(Tesseract_INCLUDE_DIR "")
   SET(Tesseract_LIBRARY user32 ws2_32)
   SET(CMAKE_CXX_FLAGS "/D__MSW32__ /DWIN32 /D_WINDOWS /D_CRT_SECURE_NO_WARNINGS")
ENDIF()


LINK_DIRECTORIES(${OpenCV_LIBRARY_DIR})

# tom SET(CMAKE_SWIG_FLAGS -package ${PACKAGE})
SET(CMAKE_SWIG_FLAGS -package ${NATIVE_PACKAGE})
SET(SWIG_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})

IF(LINUX OR APPLE)
   FIND_LIBRARY(TIFF_LIBS NAMES tiff)
   LIST(APPEND OpenCV_LIBS ${TIFF_LIBS})
   LINK_DIRECTORIES(${TIFF_LIB_DIR})
ENDIF()

SET(BUILD_TARGETS
   #TODO move VDictProxy to swig
   VDictProxy
)

IF(WIN32)
   LIST(APPEND BUILD_TARGETS Win32Util)

   ADD_LIBRARY(Win32Util SHARED
      Win32Util.cc
      org_sikuli_script_Win32Util.h
   )
   TARGET_LINK_LIBRARIES(Win32Util ${JAVA_AWT_LIBRARY})
ENDIF()


IF(APPLE)
   LIST(APPEND BUILD_TARGETS MacUtil)
   FIND_LIBRARY(JAVA_LIBRARY JavaVM)
   FIND_LIBRARY(COCOA_LIBRARY Cocoa)
   FIND_LIBRARY(CARBON_LIBRARY Carbon)
   FIND_LIBRARY(COREFOUNDATION_LIBRARY CoreFoundation)
   SET(EXTRA_LIBS ${JAVA_LIBRARY} ${COCOA_LIBRARY} ${CARBON_LIBRARY} ${COREFOUNDATION_LIBRARY})

   ADD_LIBRARY(MacUtil SHARED
      MacUtil.m
      org_sikuli_script_MacUtil.h
   )
   TARGET_LINK_LIBRARIES(MacUtil ${EXTRA_LIBS})

   LIST(APPEND BUILD_TARGETS MacHotkeyManager)

   ADD_LIBRARY(MacHotkeyManager SHARED
      MacHotkeyManager.cc
      sikuli-debug.cpp
      org_sikuli_script_internal_hotkey_MacHotkeyManager.h
   )
   TARGET_LINK_LIBRARIES(MacHotkeyManager ${EXTRA_LIBS})
ENDIF()

SET(NATIVE_LIBS
   VisionProxy
   ${BUILD_TARGETS}
)
message("NATIVE_LIBS: ${NATIVE_LIBS}")

ADD_LIBRARY(VDictProxy SHARED
   VDictProxy.cc
   org_sikuli_script_VDictProxy.h
)
TARGET_LINK_LIBRARIES(VDictProxy ${OpenCV_LIBS})


## SWIG: generate a JNI wrapper 
SET_SOURCE_FILES_PROPERTIES(vision.i PROPERTIES CPLUSPLUS ON)
SWIG_ADD_MODULE(VisionProxy java vision.i
   TimingBlock.cc
   cvgui.cpp
   finder.cpp
   imgdb.cpp
   pyramid-template-matcher.cpp
   tessocr.cpp
   vision.cpp
   sikuli-debug.cpp
   ${TESSERACT_SOURCES}
) 
SWIG_LINK_LIBRARIES(VisionProxy ${Tesseract_LIBRARY} ${OpenCV_LIBS})  


#TODO: replace jni custom commands by swig
foreach(JNI_HEADER ${JNI_HEADERS})
   STRING(REGEX REPLACE "_" "." JNI_CLASS ${JNI_HEADER})
   STRING(REGEX REPLACE "\\.h$" "" JNI_CLASS ${JNI_CLASS})
   STRING(REGEX REPLACE "\\." "/" JNI_JAVA_SOURCE ${JNI_CLASS})
   SET(JNI_JAVA_CLASS "${JNI_JAVA_SOURCE}.class")
   SET(JNI_JAVA_SOURCE "${JNI_JAVA_SOURCE}.java")
   ADD_CUSTOM_COMMAND(
      OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/${JNI_HEADER}
      COMMAND ${JAVA_JAVA_H} -d ${CMAKE_CURRENT_SOURCE_DIR} 
                             -classpath ${BINARY_CLASS_DIR} ${JNI_CLASS}
      DEPENDS ${JAVA_SRC_DIR}/${JNI_JAVA_SOURCE}
   )
endforeach(JNI_HEADER ${JNI_HEADERS})


foreach(BUILD_TARGET ${BUILD_TARGETS})
   TARGET_LINK_LIBRARIES(${BUILD_TARGET} ${OpenCV_LIBS})
   add_dependencies(${BUILD_TARGET} ${PROJECT_NAME}.classes)
   IF(APPLE)
      SET_TARGET_PROPERTIES(${BUILD_TARGET} PROPERTIES SUFFIX ".jnilib")
   ENDIF(APPLE)
endforeach(BUILD_TARGET ${BUILD_TARGETS})

add_dependencies(${JAR_FILE}.libs-in-jar ${NATIVE_LIBS})

=== sikuli-script/src/test/java/CMakeLists.txt ===
# Copyright 2010-2011, Sikuli.org
# Released under the MIT License.

SET(JAVA_TEST_FILES 
   ${CMAKE_SWIG_OUTDIR}/*.java
   org/sikuli/script/*.java
)

add_custom_target( ${PROJECT_NAME}.test.classes
    COMMAND ${JAVA_COMPILE} -d ${TEST_CLASS_DIR} -classpath "${TEST_CLASSPATH}"
            ${JAVA_TEST_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
     

add_dependencies(${PROJECT_NAME}.test.classes ${PROJECT_NAME}.classes)

=== sikuli-script/src/test/native/Makefile ===

NATIVE_TEST_PATH=../../target/test
NATIVE_TEST_SUITE=TestFinder.h
NATIVE_TEST_RUNNER=TestFinderRunner.cpp
NATIVE_TEST_RUNNER_BIN=$(NATIVE_TEST_PATH)/$(NATIVE_TEST_RUNNER:%.cpp=%)

SRC_PATH=../../main/native
OBJS:=$(shell ls $(SRC_PATH)/*.o)
OBJS:=$(OBJS:%screenmatch.o=)

include $(SRC_PATH)/Makefile.common

CXXFLAGS+=-I/opt/cxxtest -I$(SRC_PATH) -lcv -lcxcore -lcvaux -lhighgui
LDFLAGS:=$(LDFLAGS:-dynamiclib=) -L/usr/local/libx

default: run-test

$(NATIVE_TEST_PATH):

$(NATIVE_TEST_RUNNER): $(NATIVE_TEST_SUITE)
	cxxtestgen.pl --error-printer -o $@ $^

$(NATIVE_TEST_RUNNER_BIN): $(NATIVE_TEST_RUNNER) $(OBJS)
	mkdir -p $(NATIVE_TEST_PATH)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^

run-test: $(NATIVE_TEST_RUNNER_BIN)
	time $(NATIVE_TEST_RUNNER_BIN)

screenmatch: $(OBJS) screenmatch.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $^
